LeetCode 945 - Minimum Increment to Make Array Unique


https://leetcode.com/problems/minimum-increment-to-make-array-unique/
Given an array of integers A, a move consists of choosing any A[i], and incrementing it by 1.
Return the least number of moves to make every value in A unique.

Example 1:
Input: [1,2,2]
Output: 1
Explanation:  After 1 move, the array could be [1, 2, 3].
Example 2:
Input: [3,2,1,2,1,7]
Output: 6
Explanation:  After 6 moves, the array could be [3, 4, 1, 2, 5, 7].
It can be shown with 5 or less moves that it is impossible for the array to have all unique values.

Note:
  1. 0 <= A.length <= 40000
  2. 0 <= A[i] < 40000
https://leetcode.com/problems/minimum-increment-to-make-array-unique/discuss/197687/C%2B%2BJavaPython-Straight-Forward


Sort the array.
Compared with previous number,
the current number need to be at least prev + 1.
Time Complexity: O(NlogN)


    public int minIncrementForUnique(int[] A) {
        Arrays.sort(A);
        int res = 0, need = 0;
        for (int a : A) {
            res += Math.max(need - a, 0);
            need = Math.max(a, need) + 1;
        }
        return res;
    }
https://leetcode.com/problems/minimum-increment-to-make-array-unique/discuss/197713/C%2B%2B-concise-solution-O(nlogn)-complexity-with-explanation-and-example-step-by-step
The idea is to sort the input -O(nlogn)- , then we move forward from the beginning of the array till the end.
As soon as we found a condition that the current element is less than or equal to the previous elements then we need to update the current array element.
here is an example of the given input.
A = [3,2,1,2,1,7]
Sorted A = [1,1,2,2,3,7]
After reaching the second 1 on the array since the condition is satisfied A[i]<=A[i-1] so we need to update the A[i] by A[i-1]+1.
At the same time wee need to keep track of result by
result += A[i-1]+ 1 - A[i];
The rest of iterations are as following :
A = [1,2,2,2,3,7]
res= 1
A = [1,2,3,2,3,7]
res= 2
A = [1,2,3,4,3,7]
res= 4


A = [1,2,3,4,5,7]
res= 6
    int minIncrementForUnique(vector<int>& A) {
        int s = A.size();
        int res=0;
        if (s<2)  return 0;
        sort(A.begin(),A.end());        
        for (int i=1; i<s; ++i) {
            if (A[i]<=A[i-1]){
                res+=A[i-1]+1 -A[i];
                A[i]= A[i-1]+1;
            }
        }
        return res;
    }


Approach 2: Maintain Duplicate Info
Let's imagine the array is sorted and we are moving from left to right. As in Approach 1, we want to take duplicate values to release later.
Algorithm
There are two cases.
  • If A[i-1] == A[i], we have a duplicate to take.
  • If A[i-1] < A[i], we might be able to place our taken values into those free positions. Specifically, we have give = min(taken, A[i] - A[i-1] - 1) possible values to release, and they will have final values A[i-1] + 1, A[i-1] + 2, ..., A[i-1] + give. This has a sum of A[i-1] * \text{give} + (\sum_{k=1}^{give}).
  • Time Complexity: O(N\log N), where N is the length of A.
  • Space Complexity: O(N) in additional space complexity, depending on the specific implementation of the built in sort. 
  public int minIncrementForUnique(int[] A) {
    Arrays.sort(A);
    int ans = 0, taken = 0;

    for (int i = 1; i < A.length; ++i) {
      if (A[i - 1] == A[i]) {
        taken++;
        ans -= A[i];
      } else {
        int give = Math.min(taken, A[i] - A[i - 1] - 1);
        ans += give * (give + 1) / 2 + give * A[i - 1];
        taken -= give;
      }
    }

    if (A.length > 0)
      ans += taken * (taken + 1) / 2 + taken * A[A.length - 1];

    return ans;

  }
https://leetcode.com/problems/minimum-increment-to-make-array-unique/discuss/198215/Java-O(n-%2B-m)-solution-without-sort


    public int minIncrementForUnique(int[] A) {
        int[] count = new int[40002];
        int result = 0;
        int max = 0;
        for (int a : A) {
            count[a]++;
            max = Math.max(max, a);
        }
        for (int i = 0; i < max; i++) {
            if (count[i] <= 1) {
                continue;
            }
            int diff = count[i] - 1;
            result += diff;
            count[i + 1] += diff;
            count[i] = 1;
        }
        int diff = count[max] - 1;
        result += (1 + diff) * diff / 2;
        return result;
    }
Where n is the size of input, m is the largest number of input with the maximize of 40,000.
Use Arithmetic progression to count the final result.


Let's count the quantity of each element. Clearly, we want to increment duplicated values.
For each duplicate value, we could do a "brute force" solution of incrementing it repeatedly until it is not unique. However, we might do a lot of work - consider the work done by an array of all ones. We should think of how to amend our solution to solve this case as well.
What we can do instead is lazily evaluate our increments. If for example we have [1, 1, 1, 1, 3, 5], we don't need to process all the increments of duplicated 1s. We could take three ones (taken = [1, 1, 1]) and continue processing. When we find an empty place like 24, or 6, we can then recover that our increment will be 2-14-1, and 6-1.
Algorithm
Count the values. For each possible value x:
  • If there are 2 or more values x in A, save the extra duplicated values to increment later.
  • If there are 0 values x in A, then a saved value v gets incremented to x.
In Java, the code is less verbose with a slight optimization: we record only the number of saved values, and we subtract from the answer in advance. In the [1, 1, 1, 1, 3, 5] example, we do taken = 3 and ans -= 3 in advance, and later we do ans += 2; ans += 4; ans += 6. This optimization is also used in Approach 2.
  public int minIncrementForUnique(int[] A) {
    int[] count = new int[100000];
    for (int x : A)
      count[x]++;

    int ans = 0, taken = 0;

    for (int x = 0; x < 100000; ++x) {
      if (count[x] >= 2) {
        taken += count[x] - 1;
        ans -= x * (count[x] - 1);
      } else if (taken > 0 && count[x] == 0) {
        taken--;
        ans += x;
      }
    }

    return ans;
  }







Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts